Index: issm/branches/trunk-jpl-damage/src/m/classes/clusters/pfe.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/clusters/pfe.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/clusters/pfe.m	(revision 12878)
@@ -8,5 +8,5 @@
 classdef pfe
     properties (SetAccess=public)  
-		 % {{{1
+		 % {{{
 		 name='pfe'
 		 login='';
@@ -29,5 +29,5 @@
 	 end
 	 methods
-		 function cluster=pfe(varargin) % {{{1
+		 function cluster=pfe(varargin) % {{{
 
 			 %initialize cluster using default settings if provided
@@ -38,5 +38,5 @@
 		 end
 		 %}}}
-		 function disp(cluster) % {{{1
+		 function disp(cluster) % {{{
 			 %  display the object
 			 disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
@@ -56,5 +56,5 @@
 		 end
 		 %}}}
-		 function checkconsistency(cluster,md,solution,analyses) % {{{1
+		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
 			 available_queues={'long','normal','debug'};
@@ -68,9 +68,9 @@
 				 if cluster.hyperthreading,
 					 if ((cluster.cpuspernode>16 ) | (cluster.cpuspernode<1)),
-						 checkmessage('cpuspernode should be between 1 and 16 for ''neh'' and ''har'' processors in hyperthreading mode');
+						 md = checkmessage(md,'cpuspernode should be between 1 and 16 for ''neh'' and ''har'' processors in hyperthreading mode');
 					 end
 				 else
 					 if ((cluster.cpuspernode>8 ) | (cluster.cpuspernode<1)),
-						 checkmessage('cpuspernode should be between 1 and 8 for ''neh'' and ''har'' processors');
+						 md = checkmessage(md,'cpuspernode should be between 1 and 8 for ''neh'' and ''har'' processors');
 					 end
 				 end
@@ -78,35 +78,31 @@
 				 if cluster.hyperthreading,
 					 if ((cluster.cpuspernode>24 ) | (cluster.cpuspernode<1)),
-						 checkmessage('cpuspernode should be between 1 and 24 for ''wes'' processors in hyperthreading mode');
+						 md = checkmessage(md,'cpuspernode should be between 1 and 24 for ''wes'' processors in hyperthreading mode');
 					 end
 				 else
 					 if ((cluster.cpuspernode>12 ) | (cluster.cpuspernode<1)),
-						 checkmessage('cpuspernode should be between 1 and 12 for ''wes'' processors');
-					 end
-				 end
-			 else
-				 checkmessage('unknown processor type, should be ''neh'',''wes'' or ''har''');
+						 md = checkmessage(md,'cpuspernode should be between 1 and 12 for ''wes'' processors');
+					 end
+				 end
+			 else
+				 md = checkmessage(md,'unknown processor type, should be ''neh'',''wes'' or ''har''');
 			 end
 
 			 %Miscelaneous
-			 if isempty(cluster.login), checkmessage('login empty'); end
-			 if isempty(cluster.codepath), checkmessage('codepath empty'); end
-			 if isempty(cluster.executionpath), checkmessage('executionpath empty'); end
-
-		 end
-		 %}}}
-		 function BuildQueueScript(cluster,md) % {{{1
-
-			 %retrieve parameters 
-			 modelname=md.miscellaneous.name; 
-			 solution=md.private.solution;
-			 isvalgrind=md.debug.valgrind;
+			 if isempty(cluster.login), md = checkmessage(md,'login empty'); end
+			 if isempty(cluster.codepath), md = checkmessage(md,'codepath empty'); end
+			 if isempty(cluster.executionpath), md = checkmessage(md,'executionpath empty'); end
+
+		 end
+		 %}}}
+		 function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof) % {{{
+
+			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
 
 			 %compute number of processors
 			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
-			 %open file for writing: 
+			 %write queuing script 
 			 fid=fopen([modelname '.queue'],'w');
-
 			 fprintf(fid,'#PBS -S /bin/bash\n');
 %			 fprintf(fid,'#PBS -N %s\n',modelname);
@@ -118,24 +114,15 @@
 			 fprintf(fid,'#PBS -o %s.outlog \n',modelname);
 			 fprintf(fid,'#PBS -e %s.errlog \n\n',modelname);
-
 			 fprintf(fid,'. /usr/share/modules/init/bash\n\n');
-
 			 fprintf(fid,'module load comp-intel/11.1.046\n');
 			 fprintf(fid,'module load mpi/mpt.1.25\n');
 			 fprintf(fid,'module load math/intel_mkl_64_10.0.011\n\n');
-
 			 fprintf(fid,'export PATH="$PATH:."\n\n');
 			 fprintf(fid,'export MPI_GROUP_MAX=64\n\n');
-
 			 fprintf(fid,'cd $PBS_O_WORKDIR\n\n');
-
 			 fprintf(fid,'mpiexec -np %i %s/issm.exe %s $PBS_O_WORKDIR %s\n',cluster.np,cluster.codepath,EnumToString(solution),modelname);
-
-			 if ~md.settings.io_gather,
-				 %concatenate the output files:
+			 if ~io_gather, %concatenate the output files:
 				 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
 			 end
-
-			 %close file
 			 fclose(fid);
 
@@ -148,7 +135,5 @@
 					 fprintf(fid,'mpiexec -np %i valgrind --leak-check=full %s/issm.exe %s $PBS_O_WORKDIR %s\n',cluster.np,cluster.codepath,EnumToString(solution),modelname);
 				 end
-
-				 if ~md.settings.io_gather,
-					 %concatenate the output files:
+				 if ~io_gather, %concatenate the output files:
 					 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
 				 end
@@ -160,90 +145,57 @@
 			 end
 		 end %}}}
-		 function LaunchQueueJob(cluster,md,options)% {{{1
-			 
+		 function LaunchQueueJob(cluster,modelname,dirname,filelist)% {{{
+
+			 %compress the files into one zip.
+			 compressstring=['tar -zcf ' dirname '.tar.gz '];
+			 for i=1:numel(filelist),
+				 compressstring = [compressstring ' ' filelist{i}];
+			 end
+			 if cluster.interactive,
+				 compressstring = [compressstring ' ' modelname '.run '  modelname '.errlog ' modelname '.outlog '];
+			 end
+			 system(compressstring);
+
+			 disp('uploading input file and queueing script');
+			 if cluster.interactive,
+				 directory=[cluster.executionpath '/Interactive' num2str(cluster.interactive)];
+			 else 
+				 directory=cluster.executionpath;
+			 end
+
+			 if ~cluster.bbftp,
+				 issmscpout(cluster.name,directory,cluster.login,cluster.port,{[dirname '.tar.gz']});
+			 else
+				 issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[dirname '.tar.gz']});
+			 end
+
 			 %lauch command, to be executed via ssh
 			 if ~cluster.interactive, 
-				launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' md.private.runtimename ' && mkdir ' md.private.runtimename ...
-			                ' && cd ' md.private.runtimename ' && mv ../' md.private.runtimename '.tar.gz ./ && tar -zxf ' md.private.runtimename '.tar.gz  && qsub ' md.miscellaneous.name '.queue '];
-			else
-				launchcommand=['cd ' cluster.executionpath '/Interactive' num2str(cluster.interactive) ' && tar -zxf ' md.private.runtimename '.tar.gz'];
-			end
-
-			if ~strcmpi(options.batch,'yes'),
-				
-				%compress the files into one zip.
-				compressstring=['tar -zcf ' md.private.runtimename '.tar.gz ' md.miscellaneous.name '.bin ' md.miscellaneous.name '.queue '  md.miscellaneous.name '.petsc '];
-				if md.qmu.isdakota,
-					compressstring=[compressstring md.miscellaneous.name '.qmu.in '];
-				end
-				if cluster.interactive,
-					compressstring=[compressstring md.miscellaneous.name '.run ' md.miscellaneous.name '.errlog ' md.miscellaneous.name '.outlog '];
-				end
-				system(compressstring);
-				
-				disp('uploading input file and queueing script');
-				if cluster.interactive,
-					directory=[cluster.executionpath '/Interactive' num2str(cluster.interactive)];
-				else 
-					directory=cluster.executionpath;
-				end
-				
-				if ~cluster.bbftp,
-					issmscpout(cluster.name,directory,cluster.login,cluster.port,{[md.private.runtimename '.tar.gz']});
-				else
-					issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[md.private.runtimename '.tar.gz']});
-				end
-				
-				disp('launching solution sequence on remote cluster');
-				issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
-
-			else
-				disp('batch mode requested: not launching job interactively');
-				disp('launch solution sequence on remote cluster by hand');
-			end
-		 end
-		 %}}}
-		 function Download(cluster,md)% {{{1
-
-			%some check
-			if isempty(md.private.runtimename),
-				if ~cluster.interactive,
-					error('pfe Download error message: supply runtime name for results to be loaded!');
-				end
-			end
-
-			%Figure out the  directory where all the files are in: 
-			if ~cluster.interactive,
-				directory=[cluster.executionpath '/' md.private.runtimename '/'];
-			else
-				directory=[cluster.executionpath '/Interactive' num2str(cluster.interactive) '/'];
-			end
-
-			%What packages are we picking up from remote cluster
-			if ~cluster.interactive,
-				packages={[md.miscellaneous.name '.outlog'],[md.miscellaneous.name '.errlog']};
-			else
-				packages={};
-			end
-			if md.qmu.isdakota,
-				packages{end+1}=[md.miscellaneous.name '.qmu.err'];
-				packages{end+1}=[md.miscellaneous.name '.qmu.out'];
-				if isfield(md.qmu.params,'tabular_graphics_data'),
-					if md.qmu.params.tabular_graphics_data==true,
-						packages{end+1}='dakota_tabular.dat'; 
-					end
-				end
-			else
-				packages{end+1}=[md.miscellaneous.name '.outbin'];
-			end
-
-			%copy files from cluster to present directory
-			if ~cluster.bbftp,
-				issmscpin(cluster.name, cluster.login, cluster.port, directory, packages);
-			else
-				issmbbftpin(cluster.name, cluster.login, cluster.port, cluster.numstreams, directory, packages);
-			end
-
-		end %}}}
+				 launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+					 ' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && qsub ' modelname '.queue '];
+			 else
+				 launchcommand=['cd ' cluster.executionpath '/Interactive' num2str(cluster.interactive) ' && tar -zxf ' dirname '.tar.gz'];
+			 end
+
+			 disp('launching solution sequence on remote cluster');
+			 issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
+		 end
+		 %}}}
+		 function Download(cluster,dirname,filelist)% {{{
+
+			 %copy files from cluster to current directory
+			 if ~cluster.interactive,
+				 directory=[cluster.executionpath '/' dirname '/'];
+			 else
+				 directory=[cluster.executionpath '/Interactive' num2str(cluster.interactive) '/'];
+			 end
+
+			 if ~cluster.bbftp,
+				 issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
+			 else
+				 issmbbftpin(cluster.name, cluster.login, cluster.port, cluster.numstreams, directory, filelist);
+			 end
+
+		 end %}}}
 	end
 end
Index: issm/branches/trunk-jpl-damage/src/m/classes/clusters/pollux.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/clusters/pollux.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/clusters/pollux.m	(revision 12878)
@@ -8,5 +8,5 @@
 classdef pollux
     properties (SetAccess=public) 
-		 % {{{1
+		 % {{{
 		 name='pollux'
 		 login='username';
@@ -20,9 +20,9 @@
 	 end
 	 methods
-		 function cluster=pollux(varargin) % {{{1
+		 function cluster=pollux(varargin) % {{{
 			 cluster=AssignObjectFields(pairoptions(varargin{:}),cluster);
 		 end
 		 %}}}
-		 function disp(cluster) % {{{1
+		 function disp(cluster) % {{{
 			 %  display the object
 			 disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
@@ -37,5 +37,5 @@
 		 end
 		 %}}}
-		 function checkconsistency(cluster,md,solution,analyses) % {{{1
+		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
 			 available_queues={'shortp','longp'};
@@ -46,13 +46,11 @@
 		 end
 		 %}}}
-		 function BuildQueueScript(cluster,md) % {{{1
+		 function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof) % {{{
 
-			 %retrieve parameters 
-			 modelname=md.miscellaneous.name; 
-			 solution=md.private.solution;
+			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
 
-			 %open file for writing: 
+			 %write queuing script 
 			 fid=fopen([modelname '.queue'],'w');
-
 			 fprintf(fid,'#!/bin/sh\n');
 			 fprintf(fid,'#PBS -l walltime=%i\n',cluster.time*60); %walltime is in seconds.
@@ -64,70 +62,39 @@
 			 fprintf(fid,'#PBS -o %s.outlog \n',modelname);
 			 fprintf(fid,'#PBS -e %s.errlog \n',modelname);
-
 			 fprintf(fid,'export PBS_O_WORKDIR=%s\n',cluster.executionpath);
 			 fprintf(fid,'cd $PBS_O_WORKDIR\n');
 			 fprintf(fid,'export OMP_NUM_THREADS=1\n');
 			 fprintf(fid,'dplace -s1 -c0-%i mpiexec -np %i %s/issm.exe %s %s %s',cluster.np-1,cluster.np,cluster.codepath,EnumToString(solution),cluster.executionpath,modelname);
-
-			 %close file
 			 fclose(fid);
 
 		 end
 		 %}}}
-		 function LaunchQueueJob(cluster,md,options)% {{{1
-			 
-			 %lauch command, to be executed via ssh
-			 launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' md.private.runtimename ' && mkdir ' md.private.runtimename ...
-			                ' && cd ' md.private.runtimename ' && mv ../' md.private.runtimename '.tar.gz ./ && tar -zxf ' md.private.runtimename '.tar.gz  && qsub ' modelname '.queue '];
+		 function LaunchQueueJob(cluster,modelname,dirname,filelist)% {{{
 
-			if ~strcmpi(options.batch,'yes'),
-				
-				%compress the files into one zip.
-				compressstring=['tar -zcf ' md.private.runtimename '.tar.gz ' md.miscellaneous.name '.bin ' md.miscellaneous.name '.queue '  md.miscellaneous.name '.petsc '];
-				if md.qmu.isdakota,
-					compressstring=[compressstring md.miscellaneous.name '.qmu.in'];
-				end
-				system(compressstring);
-				
-				disp('uploading input file and queueing script');
-				issmscpout(md.cluster.name,md.cluster.executionpath,md.cluster.login,md.cluster.port,{[md.private.runtimename '.tar.gz']});
-				
-				disp('launching solution sequence on remote cluster');
-				issmssh(md.cluster.name,md.cluster.login,md.cluster.port,launchcommand);
+			 %compress the files into one zip.
+			 compressstring=['tar -zcf ' dirname '.tar.gz '];
+			 for i=1:numel(filelist),
+				 compressstring = [compressstring ' ' filelist{i}];
+			 end
+			 if cluster.interactive,
+				 compressstring = [compressstring ' ' modelname '.errlog ' modelname '.outlog '];
+			 end
+			 system(compressstring);
 
-			else
-				disp('batch mode requested: not launching job interactively');
-				disp('launch solution sequence on remote cluster by hand');
-			end
+			 disp('uploading input file and queueing script');
+			 issmscpout(cluster.name,cluster.executionpath,cluster.login,cluster.port,{[dirname '.tar.gz']});
 
-		 end
-		 %}}}
-		 function Download(cluster,md)% {{{1
+			 disp('launching solution sequence on remote cluster');
+			 launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+				 ' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && qsub ' modelname '.queue '];
+			 issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
+		 end %}}}
+		 function Download(cluster,dirname,filelist)% {{{
 
-			%some check
-			if isempty(md.private.runtimename),
-				error('pfe Download error message: supply runtime name for results to be loaded!');
-			end
+			 %copy files from cluster to current directory
+			 directory=[cluster.executionpath '/' dirname '/'];
+			 issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
 
-			%Figure out the  directory where all the files are in: 
-			directory=[cluster.executionpath '/' md.private.runtimename '/'];
-
-			%What packages are we picking up from remote cluster
-			packages={[md.miscellaneous.name '.outlog'],[md.miscellaneous.name '.errlog']};
-			if md.qmu.isdakota,
-				packages{end+1}=[md.miscellaneous.name '.qmu.err'];
-				packages{end+1}=[md.miscellaneous.name '.qmu.out'];
-				if isfield(md.qmu.params,'tabular_graphics_data'),
-					if md.qmu.params.tabular_graphics_data==true,
-						packages{end+1}='dakota_tabular.dat'; 
-					end
-				end
-			else
-				packages{end+1}=[md.miscellaneous.name '.outbin'];
-			end
-
-			%copy files from cluster to present directory
-			issmscpin(cluster.name, cluster.login, cluster.port, directory, packages);
-		end %}}}
+		 end %}}}
 	end
 end
Index: issm/branches/trunk-jpl-damage/src/m/classes/constants.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/constants.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/constants.m	(revision 12878)
@@ -31,9 +31,9 @@
 
 		end % }}}
-		function flag = checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
-			checkfield(md,'constants.g','>',0,'size',[1 1]);
-			checkfield(md,'constants.yts','>',0,'size',[1 1]);
-			checkfield(md,'constants.referencetemperature','size',[1 1]);
+			md = checkfield(md,'constants.g','>',0,'size',[1 1]);
+			md = checkfield(md,'constants.yts','>',0,'size',[1 1]);
+			md = checkfield(md,'constants.referencetemperature','size',[1 1]);
 
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/debug.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/debug.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/debug.m	(revision 12878)
@@ -8,5 +8,5 @@
 		valgrind = false;
 		gprof    = false;
-		petsc_profiling = false;
+		profiling = false;
 	end
 	methods
@@ -27,9 +27,9 @@
 			fielddisplay(obj,'valgrind','use Valgrind to debug (0 or 1)');
 			fielddisplay(obj,'gprof','use gnu-profiler to find out where the time is spent');
-			fielddisplay(obj,'petsc_profiling','enables PETSc profiling (memory, flops, time)');
+			fielddisplay(obj,'profiling','enables profiling (memory, flops, time)');
 
 		end % }}}
 		function marshall(obj,fid) % {{{
-			WriteData(fid,'object',obj,'fieldname','petsc_profiling','format','Boolean');
+			WriteData(fid,'object',obj,'fieldname','profiling','format','Boolean');
 		end % }}}
 	end
Index: issm/branches/trunk-jpl-damage/src/m/classes/diagnostic.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/diagnostic.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/diagnostic.m	(revision 12878)
@@ -64,5 +64,5 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
@@ -70,32 +70,32 @@
 			%if ~ismember(DiagnosticHorizAnalysisEnum,analyses) |  (solution==TransientSolutionEnum & md.transient.isdiagnostic==0), return; end
 
-			checkfield(md,'diagnostic.spcvx','forcing',1);
-			checkfield(md,'diagnostic.spcvy','forcing',1);
-			if md.mesh.dimension==3, checkfield(md,'diagnostic.spcvz','forcing',1); end
-			checkfield(md,'diagnostic.restol','size',[1 1],'>',0);
-			checkfield(md,'diagnostic.reltol','size',[1 1]);
-			checkfield(md,'diagnostic.abstol','size',[1 1]);
-			checkfield(md,'diagnostic.isnewton','numel',1,'values',[0 1]);
-			checkfield(md,'diagnostic.stokesreconditioning','size',[1 1],'NaN',1);
-			checkfield(md,'diagnostic.viscosity_overshoot','size',[1 1],'NaN',1);
+			md = checkfield(md,'diagnostic.spcvx','forcing',1);
+			md = checkfield(md,'diagnostic.spcvy','forcing',1);
+			if md.mesh.dimension==3, md = checkfield(md,'diagnostic.spcvz','forcing',1); end
+			md = checkfield(md,'diagnostic.restol','size',[1 1],'>',0);
+			md = checkfield(md,'diagnostic.reltol','size',[1 1]);
+			md = checkfield(md,'diagnostic.abstol','size',[1 1]);
+			md = checkfield(md,'diagnostic.isnewton','numel',1,'values',[0 1]);
+			md = checkfield(md,'diagnostic.stokesreconditioning','size',[1 1],'NaN',1);
+			md = checkfield(md,'diagnostic.viscosity_overshoot','size',[1 1],'NaN',1);
 			if md.mesh.dimension==2,
-				checkfield(md,'diagnostic.icefront','size',[NaN 4],'NaN',1);
+				md = checkfield(md,'diagnostic.icefront','size',[NaN 4],'NaN',1);
 			else
-				checkfield(md,'diagnostic.icefront','size',[NaN 6],'NaN',1);
+				md = checkfield(md,'diagnostic.icefront','size',[NaN 6],'NaN',1);
 			end
-			checkfield(md,'diagnostic.icefront(:,end)','values',[0 1 2]);
-			checkfield(md,'diagnostic.maxiter','size',[1 1],'>=',1);
-			checkfield(md,'diagnostic.referential','size',[md.mesh.numberofvertices 6]);
+			md = checkfield(md,'diagnostic.icefront(:,end)','values',[0 1 2]);
+			md = checkfield(md,'diagnostic.maxiter','size',[1 1],'>=',1);
+			md = checkfield(md,'diagnostic.referential','size',[md.mesh.numberofvertices 6]);
 			if ~isempty(md.diagnostic.requested_outputs),
-				checkfield(md,'diagnostic.requested_outputs','size',[NaN 1]);
+				md = checkfield(md,'diagnostic.requested_outputs','size',[NaN 1]);
 			end
 
 			%singular solution
 			if ~any((~isnan(md.diagnostic.spcvx)+~isnan(md.diagnostic.spcvy))==2),
-				checkmessage(['model ' md.miscellaneous.name ' is not well posed (singular). You need at least one node with fixed velocity!'])
+				md = checkmessage(md,['model is not well posed (singular). You need at least one node with fixed velocity!']);
 			end
 			%CHECK THAT EACH LINES CONTAINS ONLY NAN VALUES OR NO NAN VALUES
 			if any(sum(isnan(md.diagnostic.referential),2)~=0 & sum(isnan(md.diagnostic.referential),2)~=6),
-				checkmessage(['model ' md.miscellaneous.name ' has problem with rotated spc. Each line of diagnostic.referential should contain either only NaN values or no NaN values']);
+				md = checkmessage(md,['Each line of diagnostic.referential should contain either only NaN values or no NaN values']);
 			end
 			%CHECK THAT THE TWO VECTORS PROVIDED ARE ORTHOGONAL
@@ -103,5 +103,5 @@
 				pos=find(sum(isnan(md.diagnostic.referential),2)==0);
 				if any(abs(dot(md.diagnostic.referential(pos,1:3)',md.diagnostic.referential(pos,4:6)'))>eps),
-					checkmessage(['model ' md.miscellaneous.name ' has problem with referential. Vectors in diagnostic.referential (colums 1 to 3 and 4 to 6) must be orthogonal']);
+					md = checkmessage(md,['Vectors in diagnostic.referential (colums 1 to 3 and 4 to 6) must be orthogonal']);
 				end
 			end
@@ -110,5 +110,5 @@
 				pos=find(md.mask.vertexongroundedice & md.mesh.vertexonbed);
 				if any(~isnan(md.diagnostic.referential(pos,:))),
-					checkmessage(['no referential should be specified for basal vertices of grounded ice']);
+					md = checkmessage(md,['no referential should be specified for basal vertices of grounded ice']);
 				end
 			end
Index: issm/branches/trunk-jpl-damage/src/m/classes/flaim.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/flaim.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/flaim.m	(revision 12878)
@@ -32,14 +32,14 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
 			if solution~=FlaimSolutionEnum, return; end
 
-			checkfield(md,'flaim.tracks','file',1);
+			md = checkfield(md,'flaim.tracks','file',1);
 			if any(isnan(md.flaim.criterion)) || isempty(md.flaim.criterion)
-				checkfield(md,'flaim.targets','file',1);
+				md = checkfield(md,'flaim.targets','file',1);
 			else
-				checkfield(md,'flaim.criterion','numel',[md.mesh.numberofvertices md.mesh.numberofelements]);
+				md = checkfield(md,'flaim.criterion','numel',[md.mesh.numberofvertices md.mesh.numberofelements]);
 			end
 
Index: issm/branches/trunk-jpl-damage/src/m/classes/flowequation.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/flowequation.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/flowequation.m	(revision 12878)
@@ -27,28 +27,30 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			if ismember(DiagnosticHorizAnalysisEnum,analyses),
 
-				checkfield(md,'flowequation.ismacayealpattyn','numel',1,'values',[0 1]);
-				checkfield(md,'flowequation.ishutter','numel',1,'values',[0 1]);
-				checkfield(md,'flowequation.isstokes','numel',1,'values',[0 1]);
-				checkfield(md,'flowequation.bordermacayeal','size',[md.mesh.numberofvertices 1],'values',[0 1]);
-				checkfield(md,'flowequation.borderpattyn','size',[md.mesh.numberofvertices 1],'values',[0 1]);
-				checkfield(md,'flowequation.borderstokes','size',[md.mesh.numberofvertices 1],'values',[0 1]);
+				md = checkfield(md,'flowequation.ismacayealpattyn','numel',1,'values',[0 1]);
+				md = checkfield(md,'flowequation.ishutter','numel',1,'values',[0 1]);
+				md = checkfield(md,'flowequation.isstokes','numel',1,'values',[0 1]);
+				md = checkfield(md,'flowequation.bordermacayeal','size',[md.mesh.numberofvertices 1],'values',[0 1]);
+				md = checkfield(md,'flowequation.borderpattyn','size',[md.mesh.numberofvertices 1],'values',[0 1]);
+				md = checkfield(md,'flowequation.borderstokes','size',[md.mesh.numberofvertices 1],'values',[0 1]);
 				if (md.mesh.dimension==2),
-					checkfield(md,'flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[1:2]);
-					checkfield(md,'flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[1:2]);
+					md = checkfield(md,'flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[1:2]);
+					md = checkfield(md,'flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[1:2]);
 				else
-					checkfield(md,'flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[0:7]);
-					checkfield(md,'flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[0:7]);
+					md = checkfield(md,'flowequation.vertex_equation','size',[md.mesh.numberofvertices 1],'values',[0:7]);
+					md = checkfield(md,'flowequation.element_equation','size',[md.mesh.numberofelements 1],'values',[0:7]);
 				end
 				if (md.flowequation.ismacayealpattyn==0 && md.flowequation.ishutter==0 && md.flowequation.isstokes==0),
-					checkmessage(['no element types set for this model. At least one of ismacayealpattyn, ishutter or isstokes need to be =1']);
+					md = checkmessage(md,['no element types set for this model. At least one of ismacayealpattyn, ishutter or isstokes need to be =1']);
 				end
 			end
 			if ismember(DiagnosticHutterAnalysisEnum,analyses),
-				if any(md.flowequation.element_equation==1 & md.mask.elementonfloatingice),
-					disp(sprintf('\n !!! Warning: Hutter''s model is not consistent on ice shelves !!!\n'));
+				if any(md.flowequation.element_equation==1),
+					if(md.flowequation.element_equation & md.mask.elementonfloatingice),
+						disp(sprintf('\n !!! Warning: Hutter''s model is not consistent on ice shelves !!!\n'));
+					end
 				end
 			end
Index: issm/branches/trunk-jpl-damage/src/m/classes/friction.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/friction.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/friction.m	(revision 12878)
@@ -22,12 +22,12 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
 			if ~ismember(DiagnosticHorizAnalysisEnum,analyses) & ~ismember(ThermalAnalysisEnum,analyses), return; end
 
-			checkfield(md,'friction.coefficient','NaN',1,'size',[md.mesh.numberofvertices 1]);
-			checkfield(md,'friction.q','NaN',1,'size',[md.mesh.numberofelements 1]);
-			checkfield(md,'friction.p','NaN',1,'size',[md.mesh.numberofelements 1]);
+			md = checkfield(md,'friction.coefficient','NaN',1,'size',[md.mesh.numberofvertices 1]);
+			md = checkfield(md,'friction.q','NaN',1,'size',[md.mesh.numberofelements 1]);
+			md = checkfield(md,'friction.p','NaN',1,'size',[md.mesh.numberofelements 1]);
 		end % }}}
 		function disp(obj) % {{{
Index: issm/branches/trunk-jpl-damage/src/m/classes/geometry.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/geometry.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/geometry.m	(revision 12878)
@@ -24,14 +24,14 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
-			checkfield(md,'geometry.surface'  ,'NaN',1,'size',[md.mesh.numberofvertices 1]);
-			checkfield(md,'geometry.bed'      ,'NaN',1,'size',[md.mesh.numberofvertices 1]);
-			checkfield(md,'geometry.thickness','NaN',1,'size',[md.mesh.numberofvertices 1],'>',0);
+			md = checkfield(md,'geometry.surface'  ,'NaN',1,'size',[md.mesh.numberofvertices 1]);
+			md = checkfield(md,'geometry.bed'      ,'NaN',1,'size',[md.mesh.numberofvertices 1]);
+			md = checkfield(md,'geometry.thickness','NaN',1,'size',[md.mesh.numberofvertices 1],'>',0);
 			if any((obj.thickness-obj.surface+obj.bed)>10^-9),
-				checkmessage(['equality thickness=surface-bed violated']);
+				md = checkmessage(md,['equality thickness=surface-bed violated']);
 			end 
 			if solution==TransientSolutionEnum & md.transient.isgroundingline,
-				checkfield(md,'geometry.bathymetry','NaN',1,'size',[md.mesh.numberofvertices 1]);
+				md = checkfield(md,'geometry.bathymetry','NaN',1,'size',[md.mesh.numberofvertices 1]);
 			end
 		end % }}}
Index: issm/branches/trunk-jpl-damage/src/m/classes/groundingline.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/groundingline.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/groundingline.m	(revision 12878)
@@ -28,19 +28,19 @@
 
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
-			checkfield(md,'groundingline.migration','values',{'None' 'AgressiveMigration' 'SoftMigration'});
+			md = checkfield(md,'groundingline.migration','values',{'None' 'AgressiveMigration' 'SoftMigration'});
 
 			if ~strcmp(obj.migration,'None'),
 				if isnan(md.geometry.bathymetry),
-					checkmessage(['requesting grounding line migration, but bathymetry is absent!']);
+					md = checkmessage(md,['requesting grounding line migration, but bathymetry is absent!']);
 				end
 				pos=find(md.mask.vertexongroundedice); 
 				if any(abs(md.geometry.bed(pos)-md.geometry.bathymetry(pos))>10^-10),
-					checkmessage(['bathymetry not equal to bed on grounded ice !']);
+					md = checkmessage(md,['bathymetry not equal to bed on grounded ice !']);
 				end
 				pos=find(md.mask.vertexonfloatingice); 
 				if any(md.geometry.bathymetry(pos)-md.geometry.bed(pos)>10^-9),
-					checkmessage(['bathymetry superior to bed on floating ice !']);
+					md = checkmessage(md,['bathymetry superior to bed on floating ice !']);
 				end
 			end
Index: issm/branches/trunk-jpl-damage/src/m/classes/hydrology.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/classes/hydrology.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/classes/hydrology.m	(revision 12878)
@@ -35,11 +35,11 @@
 			obj.stabilization=1;
 		end % }}}
-		function checkconsistency(obj,md,solution,analyses) % {{{
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
 			%Early return
 			if ~ismember(HydrologyAnalysisEnum,analyses), return; end
 
-			checkfield(md,'hydrology.spcwatercolumn','forcing',1);
-			checkfield(md,'hydrology.stabilization','>=',0);
+			md = checkfield(md,'hydrology.spcwatercolumn','forcing',1);
+			md = checkfield(md,'hydrology.stabilization','>=',0);
 		end % }}}
 		function disp(obj) % {{{
